package ServerConfig;

import ServerConfig.loader.ProgramLoaderPOA;
import org.omg.CORBA.ORB;

/**
 * @author Min Huang (khtwo)
 * The servant to start a new window and run command in it. This works only in MS Windows
 *
 */
public class LoaderServant extends ProgramLoaderPOA {
    private ORB orb;
    
    public LoaderServant( ORB orb ) {
        this.orb = orb;
        this.orb.getClass();
    }

	/* (non-Javadoc)
	 * @see loader.ProgramLoaderOperations#loadProgram(java.lang.String)
	 */
	public boolean loadProgram(String command) {
		boolean result = false;
		try {
			System.out.println("Starting " + command);
			Runtime.getRuntime().exec("cmd /c start cmd /c " + command);
			System.out.println("Command execution succeeded.");
			result = true;
		}
		catch (Exception ex) {
			System.out.println("Command execution failed.");
			result = false;
		}

		return result;
	}

}
