package BankApp;


/**
* BankApp/BankPOA.java .
*  IDL-to-Java ֲ汾 "3.2" 
*  ./bankidl/bank.idl
* 2006315  08ʱ4232 EST
*/

public abstract class BankPOA extends org.omg.PortableServer.Servant
 implements BankApp.BankOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("Open", new java.lang.Integer (0));
    _methods.put ("Deposit", new java.lang.Integer (1));
    _methods.put ("Withdraw", new java.lang.Integer (2));
    _methods.put ("Balance", new java.lang.Integer (3));
    _methods.put ("Transfer", new java.lang.Integer (4));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {
       case 0:  // BankApp/Bank/Open
       {
         String opID = in.read_string ();
         int $result = (int)0;
         $result = this.Open (opID);
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }

       case 1:  // BankApp/Bank/Deposit
       {
         String opID = in.read_string ();
         int acnt = in.read_long ();
         float amt = in.read_float ();
         float $result = (float)0;
         $result = this.Deposit (opID, acnt, amt);
         out = $rh.createReply();
         out.write_float ($result);
         break;
       }

       case 2:  // BankApp/Bank/Withdraw
       {
         String opID = in.read_string ();
         int acnt = in.read_long ();
         float amt = in.read_float ();
         float $result = (float)0;
         $result = this.Withdraw (opID, acnt, amt);
         out = $rh.createReply();
         out.write_float ($result);
         break;
       }

       case 3:  // BankApp/Bank/Balance
       {
         String opID = in.read_string ();
         int acnt = in.read_long ();
         float $result = (float)0;
         $result = this.Balance (opID, acnt);
         out = $rh.createReply();
         out.write_float ($result);
         break;
       }

       case 4:  // BankApp/Bank/Transfer
       {
         String opID = in.read_string ();
         int src = in.read_long ();
         int dest = in.read_long ();
         float amount = in.read_float ();
         float $result = (float)0;
         $result = this.Transfer (opID, src, dest, amount);
         out = $rh.createReply();
         out.write_float ($result);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:BankApp/Bank:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public Bank _this() 
  {
    return BankHelper.narrow(
    super._this_object());
  }

  public Bank _this(org.omg.CORBA.ORB orb) 
  {
    return BankHelper.narrow(
    super._this_object(orb));
  }


} // class BankPOA
